// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DDeviceDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DDeviceDesc Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DDeviceDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DDeviceDesc*)
{
    new TD3DDeviceDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Td3ddevicedesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DDeviceDesc)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DDeviceDesc::TD3DDeviceDesc()
// Description: The default constructor for the TD3DDeviceDesc object.
// --------------------------------------------------------------------------
__fastcall TD3DDeviceDesc::TD3DDeviceDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fDevCaps_Strings=NULL;
fFVFCaps_Strings=NULL;
fStencilCaps_Strings=NULL;
fTextureOpCaps_Strings=NULL;
fVertexProcessingCaps_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TD3DDeviceDesc::~TD3DDeviceDesc()
// Description: The destructor for the TD3DDeviceDesc object.
// --------------------------------------------------------------------------
__fastcall TD3DDeviceDesc::~TD3DDeviceDesc()
{
if (fDevCaps_Strings!=NULL) delete fDevCaps_Strings;
if (fFVFCaps_Strings!=NULL) delete fFVFCaps_Strings;
if (fStencilCaps_Strings!=NULL) delete fStencilCaps_Strings;
if (fTextureOpCaps_Strings!=NULL) delete fTextureOpCaps_Strings;
if (fVertexProcessingCaps_Strings!=NULL) delete fVertexProcessingCaps_Strings;
}
// --------------------------------------------------------------------------
// Property:    DevCaps
// Description: The DevCaps property defines the capabilities supported by 
//              the device. 
//              The described effect applies when the flag is set. 
// Flags:       D3DDEVCAPS_CANBLTSYSTONONLOCAL -
//                Support for blitting from system memory textures to 
//                non-local video memory textures is available. 
//              D3DDEVCAPS_CANRENDERAFTERFLIP -
//                Support for queuing rendering commands after a page flip is 
//                available.   
//              D3DDEVCAPS_DRAWPRIMTLVERTEX -
//                This device exports a DrawPrimitive aware hardware 
//                abstraction layer (HAL). 
//              D3DDEVCAPS_FLOATTLVERTEX -
//                Support for floating point values of post transform vertex 
//                data is available 
//              D3DDEVCAPS_HWRASTERIZATION -
//                Support for hardware based scene rasterization is 
//                available. 
//              D3DDEVCAPS_HWTRANSFORMANDLIGHT -
//                Support for hardware based transformations and lighting 
//                calculations is available. 
//              D3DDEVCAPS_SEPARATETEXTUREMEMORIES -
//                Support for multitexture cascading in hardware is 
//                available. 
//                A multitexture cascade device has discrete texture memory 
//                pools for each stage of the texturising process. 
//                The appropriate stage identifier must be set in the 
//                TDDSurfaceDesc->TextureStage property at creation time. 
//              D3DDEVCAPS_SORTDECREASINGZ -
//                This device needs to have its data sorted in order of 
//                decreasing depth. 
//              D3DDEVCAPS_SORTEXACT -
//                This device needs to have its data sorted exactly. 
//              D3DDEVCAPS_SORTINCREASINGZ -
//                This device needs to have its data sorted in order of 
//                increasing depth. 
//              D3DDEVCAPS_TEXTURENONLOCALVIDMEM -
//                Support for retrieving textures from nonlocal video memory 
//                is available. 
//              D3DDEVCAPS_TEXTURESYSTEMMEMORY -
//                Support for retrieving textures from system memory is 
//                available. 
//              D3DDEVCAPS_TEXTUREVIDEOMEMORY -
//                Support for retrieving textures from device memory is 
//                available. 
//              D3DDEVCAPS_TLVERTEXSYSTEMMEMORY -
//                Support for using system memory buffers for transformed and 
//                lit vertices is available. 
//              D3DDEVCAPS_TLVERTEXVIDEOMEMORY -
//                Support for using video memory buffers for transformed and 
//                lit vertices is available. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetDevCaps()
{
return fD3DDEVICEDESC7.dwDevCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetDevCaps( dword pDevCaps )
{
fD3DDEVICEDESC7.dwDevCaps = pDevCaps;
}
// --------------------------------------------------------------------------
// Property:    DeviceGuid
// Description: The DirectX GUID of the device. 
//              
//              Possible values are: 
//              
//              IID_IDirect3DHALDevice 
//              IID_IDirect3DTnLHalDevice 
//              IID_IDirect3DRGBDevice 
// --------------------------------------------------------------------------
GUID __fastcall TD3DDeviceDesc::FGetDeviceGuid()
{
return fD3DDEVICEDESC7.deviceGUID;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetDeviceGuid( GUID pDeviceGuid )
{
fD3DDEVICEDESC7.deviceGUID = pDeviceGuid;
}
// --------------------------------------------------------------------------
// Property:    DeviceRenderBitDepth
// Description: The DeviceRenderBitDepth property defines the device's 
//              rendering bit depth. 
//              
//              Possible values are one or more of the DirectDraw bit depth 
//              constants: 
//              
//              DDBD_8 
//              DDBD_16 
//              DDBD_24 
//              DDBD_32 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetDeviceRenderBitDepth()
{
return fD3DDEVICEDESC7.dwDeviceRenderBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetDeviceRenderBitDepth( dword pDeviceRenderBitDepth )
{
fD3DDEVICEDESC7.dwDeviceRenderBitDepth = pDeviceRenderBitDepth;
}
// --------------------------------------------------------------------------
// Property:    DeviceZBufferBitDepth
// Description: The DeviceZBufferBitDepth property defines the device's 
//              z-buffer bit depth. 
//              
//              Possible values are one or more of the DirectDraw bit depth 
//              constants: 
//              
//              DDBD_8 
//              DDBD_16 
//              DDBD_24 
//              DDBD_32 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetDeviceZBufferBitDepth()
{
return fD3DDEVICEDESC7.dwDeviceZBufferBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetDeviceZBufferBitDepth( dword pDeviceZBufferBitDepth )
{
fD3DDEVICEDESC7.dwDeviceZBufferBitDepth = pDeviceZBufferBitDepth;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DDeviceDesc method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DDeviceDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    ExtentsAdjust
// Description: The ExtentsAdjust property defines how much outward 
//              adjustment, in pixels, the extents rectangle needs to 
//              accomodate antialiasing kernels. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetExtentsAdjust()
{
return fD3DDEVICEDESC7.dvExtentsAdjust;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetExtentsAdjust( D3DVALUE pExtentsAdjust )
{
fD3DDEVICEDESC7.dvExtentsAdjust = pExtentsAdjust;
}
// --------------------------------------------------------------------------
// Property:    FVFCaps
// Description: The FVFCaps property defines the flexible vertex format 
//              capabilities of the device. 
//              The described effect applies when the flag is set. 
// Flags:       D3DFVFCAPS_DONOTSTRIPELEMENTS -
//                Stripping extraneous elements from the vertex format is not 
//                neccessary to improve performance. 
//              D3DFVFCAPS_TEXCOORDCOUNTMASK -
//                This flag masks the low word of the FVFCaps property. 
//                Cast these bits to a WORD to give the number of texture 
//                coordinate sets that the device can simultaneously use for 
//                multiple texture blending. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetFVFCaps()
{
return fD3DDEVICEDESC7.dwFVFCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetFVFCaps( dword pFVFCaps )
{
fD3DDEVICEDESC7.dwFVFCaps = pFVFCaps;
}
// --------------------------------------------------------------------------
// Property:    GuardBandBottom
// Description: The GuardBandBottom property defines the screen coordinate 
//              lower limit of the guard-band clipping region. 
//              Coordinates inside the guard band rectangle but outside the 
//              viewport rectangle are automatically clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetGuardBandBottom()
{
return fD3DDEVICEDESC7.dvGuardBandBottom;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetGuardBandBottom( D3DVALUE pGuardBandBottom )
{
fD3DDEVICEDESC7.dvGuardBandBottom = pGuardBandBottom;
}
// --------------------------------------------------------------------------
// Property:    GuardBandLeft
// Description: The GuardBandLeft property defines the screen coordinate left 
//              hand limit of the guard-band clipping region. 
//              Coordinates inside the guard band rectangle but outside the 
//              viewport rectangle are automatically clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetGuardBandLeft()
{
return fD3DDEVICEDESC7.dvGuardBandLeft;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetGuardBandLeft( D3DVALUE pGuardBandLeft )
{
fD3DDEVICEDESC7.dvGuardBandLeft = pGuardBandLeft;
}
// --------------------------------------------------------------------------
// Property:    GuardBandRight
// Description: The GuardBandRight property defines the screen coordinate 
//              right hand limit of the guard-band clipping region. 
//              Coordinates inside the guard band rectangle but outside the 
//              viewport rectangle are automatically clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetGuardBandRight()
{
return fD3DDEVICEDESC7.dvGuardBandRight;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetGuardBandRight( D3DVALUE pGuardBandRight )
{
fD3DDEVICEDESC7.dvGuardBandRight = pGuardBandRight;
}
// --------------------------------------------------------------------------
// Property:    GuardBandTop
// Description: The GuardBandTop property defines the screen coordinate upper 
//              limit of the guard-band clipping region. 
//              Coordinates inside the guard band rectangle but outside the 
//              viewport rectangle are automatically clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetGuardBandTop()
{
return fD3DDEVICEDESC7.dvGuardBandTop;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetGuardBandTop( D3DVALUE pGuardBandTop )
{
fD3DDEVICEDESC7.dvGuardBandTop = pGuardBandTop;
}
// --------------------------------------------------------------------------
// Property:    LineCaps
// Description: The LineCaps property references a TD3DPrimCaps component 
//              defining the line drawing capabilities of the device. 
// --------------------------------------------------------------------------
TD3DPrimCaps* __fastcall TD3DDeviceDesc::FGetLineCaps()
{
if (ComponentState.Contains(csDesigning) &&
    (fLineCaps!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fLineCaps)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fLineCaps=NULL;
    }
return fLineCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetLineCaps( TD3DPrimCaps* pLineCaps )
{
fLineCaps = pLineCaps;
}
// --------------------------------------------------------------------------
// Property:    MaxActiveLights
// Description: The MaxActiveLights property defines the maximum number of 
//              lights the hardware can support simultaneously. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxActiveLights()
{
return fD3DDEVICEDESC7.dwMaxActiveLights;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxActiveLights( dword pMaxActiveLights )
{
fD3DDEVICEDESC7.dwMaxActiveLights = pMaxActiveLights;
}
// --------------------------------------------------------------------------
// Property:    MaxAnisotropy
// Description: The MaxAnisotropy property defines the maximum value allowed 
//              for the D3DTSS_MAXANISOTROPY texture stage state. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxAnisotropy()
{
return fD3DDEVICEDESC7.dwMaxAnisotropy;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxAnisotropy( dword pMaxAnisotropy )
{
fD3DDEVICEDESC7.dwMaxAnisotropy = pMaxAnisotropy;
}
// --------------------------------------------------------------------------
// Property:    MaxSimultaneousTextures
// Description: The MaxSimultaneousTextures property defines the maximum 
//              number of texture blending stages that can have textures 
//              bound to them by the TDDirect3DDevice::SetTexture() method. 
// --------------------------------------------------------------------------
word __fastcall TD3DDeviceDesc::FGetMaxSimultaneousTextures()
{
return fD3DDEVICEDESC7.wMaxSimultaneousTextures;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxSimultaneousTextures( word pMaxSimultaneousTextures )
{
fD3DDEVICEDESC7.wMaxSimultaneousTextures = pMaxSimultaneousTextures;
}
// --------------------------------------------------------------------------
// Property:    MaxTextureAspectRatio
// Description: The MaxTextureAspectRatio property defines the maximum 
//              texture scaling supported and is usually a power of two. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxTextureAspectRatio()
{
return fD3DDEVICEDESC7.dwMaxTextureAspectRatio;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxTextureAspectRatio( dword pMaxTextureAspectRatio )
{
fD3DDEVICEDESC7.dwMaxTextureAspectRatio = pMaxTextureAspectRatio;
}
// --------------------------------------------------------------------------
// Property:    MaxTextureBlendStages
// Description: The MaxTextureBlendStages property defines the maximum number 
//              of texture blending stages the hardware supports. 
// --------------------------------------------------------------------------
word __fastcall TD3DDeviceDesc::FGetMaxTextureBlendStages()
{
return fD3DDEVICEDESC7.wMaxTextureBlendStages;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxTextureBlendStages( word pMaxTextureBlendStages )
{
fD3DDEVICEDESC7.wMaxTextureBlendStages = pMaxTextureBlendStages;
}
// --------------------------------------------------------------------------
// Property:    MaxTextureHeight
// Description: The MaxTextureHeight property defines the maximum texture 
//              height the device supports. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxTextureHeight()
{
return fD3DDEVICEDESC7.dwMaxTextureHeight;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxTextureHeight( dword pMaxTextureHeight )
{
fD3DDEVICEDESC7.dwMaxTextureHeight = pMaxTextureHeight;
}
// --------------------------------------------------------------------------
// Property:    MaxTextureRepeat
// Description: The MaxTextureRepeat property defines the integer range of 
//              post normalised texture indices. 
//              
//              If D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE is set, texture 
//              size scaling is deferred until after the texture address mode 
//              is applied. 
//              If D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE is not set, 
//              texture indices are scaled by the largest level of detail 
//              prior to interpolation. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxTextureRepeat()
{
return fD3DDEVICEDESC7.dwMaxTextureRepeat;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxTextureRepeat( dword pMaxTextureRepeat )
{
fD3DDEVICEDESC7.dwMaxTextureRepeat = pMaxTextureRepeat;
}
// --------------------------------------------------------------------------
// Property:    MaxTextureWidth
// Description: The MaxTextureWidth property defines the maximum texture 
//              width the device supports. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMaxTextureWidth()
{
return fD3DDEVICEDESC7.dwMaxTextureWidth;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxTextureWidth( dword pMaxTextureWidth )
{
fD3DDEVICEDESC7.dwMaxTextureWidth = pMaxTextureWidth;
}
// --------------------------------------------------------------------------
// Property:    MaxUserClipPlanes
// Description: The MaxUserClipPlanes property defines the maximum number of 
//              user-defined cliiping planes that are supported. 
//              
//              Values can range from 0 to D3DMAXUSERCLIPPLANES. 
//              User defined clip planes are manipulated using the 
//              TDx_3DDevice::GetClipPlane() and TDx_3DDevice::SetClipPlane() 
//              methods. 
// --------------------------------------------------------------------------
word __fastcall TD3DDeviceDesc::FGetMaxUserClipPlanes()
{
return fD3DDEVICEDESC7.wMaxUserClipPlanes;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxUserClipPlanes( word pMaxUserClipPlanes )
{
fD3DDEVICEDESC7.wMaxUserClipPlanes = pMaxUserClipPlanes;
}
// --------------------------------------------------------------------------
// Property:    MaxVertexBlendMatrices
// Description: The MaxVertexBlendMatrices property defines the maximum 
//              number of matrices the devicec can apply to multimatrix 
//              vertex blending. 
// --------------------------------------------------------------------------
word __fastcall TD3DDeviceDesc::FGetMaxVertexBlendMatrices()
{
return fD3DDEVICEDESC7.wMaxVertexBlendMatrices;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxVertexBlendMatrices( word pMaxVertexBlendMatrices )
{
fD3DDEVICEDESC7.wMaxVertexBlendMatrices = pMaxVertexBlendMatrices;
}
// --------------------------------------------------------------------------
// Property:    MaxVertexW
// Description: The MaxVertexW property defines the maximum W-based depth 
//              value supported. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DDeviceDesc::FGetMaxVertexW()
{
return fD3DDEVICEDESC7.dvMaxVertexW;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMaxVertexW( D3DVALUE pMaxVertexW )
{
fD3DDEVICEDESC7.dvMaxVertexW = pMaxVertexW;
}
// --------------------------------------------------------------------------
// Property:    MinTextureHeight
// Description: The MinTextureHeight property defines the minimum texture 
//              height the device supports. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMinTextureHeight()
{
return fD3DDEVICEDESC7.dwMinTextureHeight;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMinTextureHeight( dword pMinTextureHeight )
{
fD3DDEVICEDESC7.dwMinTextureHeight = pMinTextureHeight;
}
// --------------------------------------------------------------------------
// Property:    MinTextureWidth
// Description: The MinTextureWidth property defines the minimum texture 
//              width the device supports. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetMinTextureWidth()
{
return fD3DDEVICEDESC7.dwMinTextureWidth;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetMinTextureWidth( dword pMinTextureWidth )
{
fD3DDEVICEDESC7.dwMinTextureWidth = pMinTextureWidth;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DDEVICEDESC7 structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    StencilCaps
// Description: The StencilCaps property defines the stencil-buffer 
//              capabilities of the device. 
//              The described effect applies when the flag is set. 
//              
//              Stencil buffer entries are integer values between 0 through 
//              2n-1, where n is the bit depth of the stencil buffer. 
//              All stencil operations are assumed valid for the 
//              D3DRENDERSTATE_STENCILFAIL, D3DRENDERSTATE_STENCILPASS and 
//              D3DRENDERSTATE_STENCILFAILZFAIL render states. 
// Flags:       D3DSTENCILCAPS_DECR -
//                The decrementing of the stencil buffer entry, with the 
//                value wrapping to the maximum when the result is less than 
//                0 is supported. (D3DSTENCILOP_DECR) 
//              D3DSTENCILCAPS_DECRSAT -
//                The decrementing of the stencil buffer entry, with the 
//                value clamped to 0 when the result is less than 0 is 
//                supported. (D3DSTENCILOP_DECR) 
//              D3DSTENCILCAPS_INCR -
//                The incrementing of the stencil buffer entry, with the 
//                value wrapping to 0 when the result exceeds the maximum is 
//                supported. 
//              D3DSTENCILCAPS_INCRSAT -
//                The incrementing of the stencil buffer entry, with the 
//                value clamped to the maximum when the result exceeds the 
//                maximum is supported. (D3DSTENCILOP_INCR) 
//              D3DSTENCILCAPS_INVERT -
//                The inversion of the stencil buffer bits is supported. 
//                (D3DSTENCILOP_INVERT) 
//              D3DSTENCILCAPS_KEEP -
//                Keeping the entry in the stencil buffer without updating is 
//                supported. (D3DSTENCILOP_KEEP) 
//                This is the default value for stencil operations. 
//              D3DSTENCILCAPS_REPLACE -
//                Replacing the stencil-buffer entry with a reference value 
//                is supported. (D3DSTENCILOP_REPLACE) 
//              D3DSTENCILCAPS_ZERO -
//                Setting the stencil buffer entry to 0 is supported. 
//                (D3DSTENCILOP_ZERO) 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetStencilCaps()
{
return fD3DDEVICEDESC7.dwStencilCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetStencilCaps( dword pStencilCaps )
{
fD3DDEVICEDESC7.dwStencilCaps = pStencilCaps;
}
// --------------------------------------------------------------------------
// Property:    TextureOpCaps
// Description: The TextureOpCaps property defines the texture operation 
//              capabilities supported by the device. 
//              The described effect applies when the flag is set. 
// Flags:       D3DTEXOPCAPS_ADD -
//                Support for the D3DTOP_ADD texture blending operation is 
//                available. 
//              D3DTEXOPCAPS_ADDSIGNED -
//                Support for the D3DTOP_ADDSIGNED texture blending operation 
//                is available. 
//              D3DTEXOPCAPS_ADDSIGNED2X -
//                Support for the D3DTOP_ADDSIGNED2X texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_ADDSMOOTH -
//                Support for the D3DTOP_ADDSMOOTH texture blending operation 
//                is available. 
//              D3DTEXOPCAPS_BLENDCURRENTALPHA -
//                Support for the D3DTOP_BLENDCURRENTALPHA texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BLENDDIFFUSEALPHA -
//                Support for the D3DTOP_BLENDDIFFUSEALPHA texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BLENDFACTORALPHA -
//                Support for the D3DTOP_BLENDFACTORALPHA texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BLENDTEXTUREALPHA -
//                Support for the D3DTOP_BLENDTEXTUREALPHA texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BLENDTEXTUREALPHAPM -
//                Support for the D3DTOP_BLENDTEXTUREALPHAPM texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BUMPENVMAP -
//                Support for the D3DTOP_BUMPENVMAP texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_BUMPENVMAPLUMINANCE -
//                Support for the D3DTOP_BUMPENVMAPLUMINANCE texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_DISABLE -
//                Support for the D3DTOP_DISABLE texture blending operation 
//                is available. 
//              D3DTEXOPCAPS_DOTPRODUCT3 -
//                Support for the D3DTOP_DOTPRODUCT3 texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_MODULATE -
//                Support for the D3DTOP_MODULATE texture blending operation 
//                is available. 
//              D3DTEXOPCAPS_MODULATE2X -
//                Support for the D3DTOP_MODULATE2X texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_MODULATE4X -
//                Support for the D3DTOP_MODULATE4X texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR -
//                Support for the D3DTOP_MODULATEALPHA_ADDCOLOR texture 
//                blending operation is available. 
//              D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA -
//                Support for the D3DTOP_MODULATECOLOR_ADDALPHA texture 
//                blending operation is available. 
//              D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR -
//                Support for the D3DTOP_MODULATEINVALPHA_ADDCOLOR texture 
//                blending operation is available. 
//              D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA -
//                Support for the D3DTOP_MODULATEINVCOLOR_ADDALPHA texture 
//                blending operation is available. 
//              D3DTEXOPCAPS_PREMODULATE -
//                Support for the D3DTOP_PREMODULATE texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_SELECTARG1 -
//                Support for the D3DTOP_SELECTARG1 texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_SELECTARG2 -
//                Support for the D3DTOP_SELECTARG2 texture blending 
//                operation is available. 
//              D3DTEXOPCAPS_SUBTRACT -
//                Support for the D3DTOP_SUBTRACT texture blending operation 
//                is available. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetTextureOpCaps()
{
return fD3DDEVICEDESC7.dwTextureOpCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetTextureOpCaps( dword pTextureOpCaps )
{
fD3DDEVICEDESC7.dwTextureOpCaps = pTextureOpCaps;
}
// --------------------------------------------------------------------------
// Property:    TriCaps
// Description: The TriCaps property references a TD3DPrimCaps component 
//              defining the triangle drawing capabilities of the device. 
// --------------------------------------------------------------------------
TD3DPrimCaps* __fastcall TD3DDeviceDesc::FGetTriCaps()
{
if (ComponentState.Contains(csDesigning) &&
    (fTriCaps!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fTriCaps)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fTriCaps=NULL;
    }
return fTriCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetTriCaps( TD3DPrimCaps* pTriCaps )
{
fTriCaps = pTriCaps;
}
// --------------------------------------------------------------------------
// Property:    VertexProcessingCaps
// Description: The VertexProcessingCaps property defines the vertex 
//              processing capabilities supported by the device. 
//              The described effect applies when the flag is set. 
// Flags:       D3DVTXPCAPS_DIRECTIONALLIGHTS -
//                Support for directional lights is available. 
//              D3DVTXPCAPS_MATERIALSOURCE7 -
//                Support for selectable vertex color sources is available. 
//              D3DVTXPCAPS_POSITIONALLIGHTS -
//                Support for positional lights, including point lights and 
//                spotlights, is available. 
//              D3DVTXPCAPS_TEXGEN -
//                Support for device generated texture coordinates is 
//                available. 
//              D3DVTXPCAPS_VERTEXFOG -
//                Support for vertex fog is available. 
// --------------------------------------------------------------------------
dword __fastcall TD3DDeviceDesc::FGetVertexProcessingCaps()
{
return fD3DDEVICEDESC7.dwReserved4;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetVertexProcessingCaps( dword pVertexProcessingCaps )
{
fD3DDEVICEDESC7.dwReserved4 = pVertexProcessingCaps;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DDeviceDesc's internal D3DDEVICEDESC7 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::Clear()
{
fD3DDEVICEDESC7.dwDevCaps = 0;
ZeroMemory(&fDeviceGuid,sizeof(_GUID));
fD3DDEVICEDESC7.dwDeviceRenderBitDepth = 0;
fD3DDEVICEDESC7.dwDeviceZBufferBitDepth = 0;
fErrorValue = D3D_OK;
fD3DDEVICEDESC7.dwFVFCaps = 0;
fLineCaps = NULL;
fD3DDEVICEDESC7.dwMaxActiveLights = 0;
fD3DDEVICEDESC7.dwMaxAnisotropy = 0;
fD3DDEVICEDESC7.wMaxSimultaneousTextures = 0;
fD3DDEVICEDESC7.dwMaxTextureAspectRatio = 0;
fD3DDEVICEDESC7.wMaxTextureBlendStages = 0;
fD3DDEVICEDESC7.dwMaxTextureHeight = 0;
fD3DDEVICEDESC7.dwMaxTextureRepeat = 0;
fD3DDEVICEDESC7.dwMaxTextureWidth = 0;
fD3DDEVICEDESC7.wMaxUserClipPlanes = 0;
fD3DDEVICEDESC7.wMaxVertexBlendMatrices = 0;
fD3DDEVICEDESC7.dwMinTextureHeight = 0;
fD3DDEVICEDESC7.dwMinTextureWidth = 0;
fSize = sizeof(D3DDEVICEDESC7);
fD3DDEVICEDESC7.dwStencilCaps = 0;
fD3DDEVICEDESC7.dwTextureOpCaps = 0;
fTriCaps = NULL;
fD3DDEVICEDESC7.dwVertexProcessingCaps = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DDEVICEDESC7* __fastcall TD3DDeviceDesc::FGetInternal_D3DDEVICEDESC7_Ptr()
{
if (fLineCaps!=NULL) CopyMemory( &fD3DDEVICEDESC7.dpcLineCaps, fLineCaps->Internal_D3DPRIMCAPS_Ptr, sizeof(D3DPRIMCAPS) );
if (fTriCaps!=NULL) CopyMemory( &fD3DDEVICEDESC7.dpcTriCaps, fTriCaps->Internal_D3DPRIMCAPS_Ptr, sizeof(D3DPRIMCAPS) );
return &fD3DDEVICEDESC7;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetInternal_D3DDEVICEDESC7( D3DDEVICEDESC7* pD3DDEVICEDESC7 )
{
if (pD3DDEVICEDESC7==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DDeviceDesc::FSetInternal_D3DDEVICEDESC7()", "TDX_ERROR", "The supplied D3DDEVICEDESC7* was NULL" );
    return;
    }

CopyMemory( &fD3DDEVICEDESC7, pD3DDEVICEDESC7, sizeof(D3DDEVICEDESC7) );
Internal_D3DDEVICEDESC7_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::Internal_D3DDEVICEDESC7_Update()
{
if (fLineCaps!=NULL) CopyMemory( fLineCaps->Internal_D3DPRIMCAPS_Ptr, &fD3DDEVICEDESC7.dpcLineCaps, sizeof(D3DPRIMCAPS) );
if (fTriCaps!=NULL) CopyMemory( fTriCaps->Internal_D3DPRIMCAPS_Ptr, &fD3DDEVICEDESC7.dpcTriCaps, sizeof(D3DPRIMCAPS) );
}

// --------------------------------------------------------------------------
// Method:      FGetDevCaps_
// Description: This method returns a TD3DDeviceDesc_DevCaps_Set<> of the 
//              flags in the current fD3DDEVICEDESC7.dwDevCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DDeviceDesc_DevCaps_Set __fastcall TD3DDeviceDesc::FGetDevCaps_()
{
TD3DDeviceDesc_DevCaps_Set TempDevCaps_;
TempDevCaps_.Clear();
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_CANBLTSYSTONONLOCAL) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_canbltsystononlocal;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_CANRENDERAFTERFLIP) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_canrenderafterflip;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_DRAWPRIMTLVERTEX) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_drawprimtlvertex;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_FLOATTLVERTEX) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_floattlvertex;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_HWRASTERIZATION) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_hwrasterization;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_hwtransformandlight;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SEPARATETEXTUREMEMORIES) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_separatetexturememories;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTDECREASINGZ) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_sortdecreasingz;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTEXACT) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_sortexact;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTINCREASINGZ) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_sortincreasingz;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTURENONLOCALVIDMEM) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_texturenonlocalvidmem;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTURESYSTEMMEMORY) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_texturesystemmemory;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTUREVIDEOMEMORY) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_texturevideomemory;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TLVERTEXSYSTEMMEMORY) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_tlvertexsystemmemory;
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TLVERTEXVIDEOMEMORY) TempDevCaps_ = TempDevCaps_ << d3ddevcaps_tlvertexvideomemory;
return TempDevCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetDevCaps_( TD3DDeviceDesc_DevCaps_Set pDevCaps_ )
{
fD3DDEVICEDESC7.dwDevCaps = 0;
if (pDevCaps_.Contains(d3ddevcaps_canbltsystononlocal)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_CANBLTSYSTONONLOCAL;
if (pDevCaps_.Contains(d3ddevcaps_canrenderafterflip)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_CANRENDERAFTERFLIP;
if (pDevCaps_.Contains(d3ddevcaps_drawprimtlvertex)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_DRAWPRIMTLVERTEX;
if (pDevCaps_.Contains(d3ddevcaps_floattlvertex)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_FLOATTLVERTEX;
if (pDevCaps_.Contains(d3ddevcaps_hwrasterization)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_HWRASTERIZATION;
if (pDevCaps_.Contains(d3ddevcaps_hwtransformandlight)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_HWTRANSFORMANDLIGHT;
if (pDevCaps_.Contains(d3ddevcaps_separatetexturememories)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_SEPARATETEXTUREMEMORIES;
if (pDevCaps_.Contains(d3ddevcaps_sortdecreasingz)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_SORTDECREASINGZ;
if (pDevCaps_.Contains(d3ddevcaps_sortexact)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_SORTEXACT;
if (pDevCaps_.Contains(d3ddevcaps_sortincreasingz)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_SORTINCREASINGZ;
if (pDevCaps_.Contains(d3ddevcaps_texturenonlocalvidmem)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_TEXTURENONLOCALVIDMEM;
if (pDevCaps_.Contains(d3ddevcaps_texturesystemmemory)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_TEXTURESYSTEMMEMORY;
if (pDevCaps_.Contains(d3ddevcaps_texturevideomemory)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_TEXTUREVIDEOMEMORY;
if (pDevCaps_.Contains(d3ddevcaps_tlvertexsystemmemory)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_TLVERTEXSYSTEMMEMORY;
if (pDevCaps_.Contains(d3ddevcaps_tlvertexvideomemory)) fD3DDEVICEDESC7.dwDevCaps |= D3DDEVCAPS_TLVERTEXVIDEOMEMORY;
}
// --------------------------------------------------------------------------
// Method:      FGetDevCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'DevCaps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DDeviceDesc::FGetDevCaps_Strings()
{
// if the strings have not been allocated
if (fDevCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fDevCaps_Strings = new TStringList();
    // if the allocation failed
    if (fDevCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDeviceDesc::FGetDevCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various DevCaps_Strings" );
        return NULL;
        }
    }
fDevCaps_Strings->Clear();
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_CANBLTSYSTONONLOCAL) fDevCaps_Strings->Add("D3DDEVCAPS_CANBLTSYSTONONLOCAL");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_CANRENDERAFTERFLIP) fDevCaps_Strings->Add("D3DDEVCAPS_CANRENDERAFTERFLIP");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_DRAWPRIMTLVERTEX) fDevCaps_Strings->Add("D3DDEVCAPS_DRAWPRIMTLVERTEX");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_FLOATTLVERTEX) fDevCaps_Strings->Add("D3DDEVCAPS_FLOATTLVERTEX");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_HWRASTERIZATION) fDevCaps_Strings->Add("D3DDEVCAPS_HWRASTERIZATION");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) fDevCaps_Strings->Add("D3DDEVCAPS_HWTRANSFORMANDLIGHT");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SEPARATETEXTUREMEMORIES) fDevCaps_Strings->Add("D3DDEVCAPS_SEPARATETEXTUREMEMORIES");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTDECREASINGZ) fDevCaps_Strings->Add("D3DDEVCAPS_SORTDECREASINGZ");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTEXACT) fDevCaps_Strings->Add("D3DDEVCAPS_SORTEXACT");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_SORTINCREASINGZ) fDevCaps_Strings->Add("D3DDEVCAPS_SORTINCREASINGZ");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTURENONLOCALVIDMEM) fDevCaps_Strings->Add("D3DDEVCAPS_TEXTURENONLOCALVIDMEM");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTURESYSTEMMEMORY) fDevCaps_Strings->Add("D3DDEVCAPS_TEXTURESYSTEMMEMORY");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TEXTUREVIDEOMEMORY) fDevCaps_Strings->Add("D3DDEVCAPS_TEXTUREVIDEOMEMORY");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TLVERTEXSYSTEMMEMORY) fDevCaps_Strings->Add("D3DDEVCAPS_TLVERTEXSYSTEMMEMORY");
if (fD3DDEVICEDESC7.dwDevCaps & D3DDEVCAPS_TLVERTEXVIDEOMEMORY) fDevCaps_Strings->Add("D3DDEVCAPS_TLVERTEXVIDEOMEMORY");
return fDevCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetFVFCaps_
// Description: This method returns a TD3DDeviceDesc_FVFCaps_Set<> of the 
//              flags in the current fD3DDEVICEDESC7.dwFVFCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DDeviceDesc_FVFCaps_Set __fastcall TD3DDeviceDesc::FGetFVFCaps_()
{
TD3DDeviceDesc_FVFCaps_Set TempFVFCaps_;
TempFVFCaps_.Clear();
if (fD3DDEVICEDESC7.dwFVFCaps & D3DFVFCAPS_DONOTSTRIPELEMENTS) TempFVFCaps_ = TempFVFCaps_ << d3dfvfcaps_donotstripelements;
if (fD3DDEVICEDESC7.dwFVFCaps & D3DFVFCAPS_TEXCOORDCOUNTMASK) TempFVFCaps_ = TempFVFCaps_ << d3dfvfcaps_texcoordcountmask;
return TempFVFCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetFVFCaps_( TD3DDeviceDesc_FVFCaps_Set pFVFCaps_ )
{
fD3DDEVICEDESC7.dwFVFCaps = 0;
if (pFVFCaps_.Contains(d3dfvfcaps_donotstripelements)) fD3DDEVICEDESC7.dwFVFCaps |= D3DFVFCAPS_DONOTSTRIPELEMENTS;
if (pFVFCaps_.Contains(d3dfvfcaps_texcoordcountmask)) fD3DDEVICEDESC7.dwFVFCaps |= D3DFVFCAPS_TEXCOORDCOUNTMASK;
}
// --------------------------------------------------------------------------
// Method:      FGetFVFCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'FVFCaps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DDeviceDesc::FGetFVFCaps_Strings()
{
// if the strings have not been allocated
if (fFVFCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fFVFCaps_Strings = new TStringList();
    // if the allocation failed
    if (fFVFCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDeviceDesc::FGetFVFCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various FVFCaps_Strings" );
        return NULL;
        }
    }
fFVFCaps_Strings->Clear();
if (fD3DDEVICEDESC7.dwFVFCaps & D3DFVFCAPS_DONOTSTRIPELEMENTS) fFVFCaps_Strings->Add("D3DFVFCAPS_DONOTSTRIPELEMENTS");
if (fD3DDEVICEDESC7.dwFVFCaps & D3DFVFCAPS_TEXCOORDCOUNTMASK) fFVFCaps_Strings->Add("D3DFVFCAPS_TEXCOORDCOUNTMASK");
return fFVFCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetStencilCaps_
// Description: This method returns a TD3DDeviceDesc_StencilCaps_Set<> of the 
//              flags in the current fD3DDEVICEDESC7.dwStencilCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DDeviceDesc_StencilCaps_Set __fastcall TD3DDeviceDesc::FGetStencilCaps_()
{
TD3DDeviceDesc_StencilCaps_Set TempStencilCaps_;
TempStencilCaps_.Clear();
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_DECR) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_decr;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_DECRSAT) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_decrsat;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INCR) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_incr;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INCRSAT) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_incrsat;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INVERT) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_invert;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_KEEP) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_keep;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_REPLACE) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_replace;
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_ZERO) TempStencilCaps_ = TempStencilCaps_ << d3dstencilcaps_zero;
return TempStencilCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetStencilCaps_( TD3DDeviceDesc_StencilCaps_Set pStencilCaps_ )
{
fD3DDEVICEDESC7.dwStencilCaps = 0;
if (pStencilCaps_.Contains(d3dstencilcaps_decr)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_DECR;
if (pStencilCaps_.Contains(d3dstencilcaps_decrsat)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_DECRSAT;
if (pStencilCaps_.Contains(d3dstencilcaps_incr)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_INCR;
if (pStencilCaps_.Contains(d3dstencilcaps_incrsat)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_INCRSAT;
if (pStencilCaps_.Contains(d3dstencilcaps_invert)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_INVERT;
if (pStencilCaps_.Contains(d3dstencilcaps_keep)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_KEEP;
if (pStencilCaps_.Contains(d3dstencilcaps_replace)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_REPLACE;
if (pStencilCaps_.Contains(d3dstencilcaps_zero)) fD3DDEVICEDESC7.dwStencilCaps |= D3DSTENCILCAPS_ZERO;
}
// --------------------------------------------------------------------------
// Method:      FGetStencilCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'StencilCaps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DDeviceDesc::FGetStencilCaps_Strings()
{
// if the strings have not been allocated
if (fStencilCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fStencilCaps_Strings = new TStringList();
    // if the allocation failed
    if (fStencilCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDeviceDesc::FGetStencilCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various StencilCaps_Strings" );
        return NULL;
        }
    }
fStencilCaps_Strings->Clear();
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_DECR) fStencilCaps_Strings->Add("D3DSTENCILCAPS_DECR");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_DECRSAT) fStencilCaps_Strings->Add("D3DSTENCILCAPS_DECRSAT");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INCR) fStencilCaps_Strings->Add("D3DSTENCILCAPS_INCR");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INCRSAT) fStencilCaps_Strings->Add("D3DSTENCILCAPS_INCRSAT");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_INVERT) fStencilCaps_Strings->Add("D3DSTENCILCAPS_INVERT");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_KEEP) fStencilCaps_Strings->Add("D3DSTENCILCAPS_KEEP");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_REPLACE) fStencilCaps_Strings->Add("D3DSTENCILCAPS_REPLACE");
if (fD3DDEVICEDESC7.dwStencilCaps & D3DSTENCILCAPS_ZERO) fStencilCaps_Strings->Add("D3DSTENCILCAPS_ZERO");
return fStencilCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetTextureOpCaps_
// Description: This method returns a TD3DDeviceDesc_TextureOpCaps_Set<> of 
//              the flags in the current fD3DDEVICEDESC7.dwTextureOpCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DDeviceDesc_TextureOpCaps_Set __fastcall TD3DDeviceDesc::FGetTextureOpCaps_()
{
TD3DDeviceDesc_TextureOpCaps_Set TempTextureOpCaps_;
TempTextureOpCaps_.Clear();
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADD) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_add;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSIGNED) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_addsigned;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSIGNED2X) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_addsigned2x;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSMOOTH) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_addsmooth;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDCURRENTALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_blendcurrentalpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDDIFFUSEALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_blenddiffusealpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDFACTORALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_blendfactoralpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_blendtexturealpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHAPM) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_blendtexturealphapm;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BUMPENVMAP) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_bumpenvmap;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BUMPENVMAPLUMINANCE) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_bumpenvmapluminance;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_DISABLE) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_disable;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_DOTPRODUCT3) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_dotproduct3;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulate;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE2X) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulate2x;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE4X) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulate4x;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulatealpha_addcolor;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulatecolor_addalpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulateinvalpha_addcolor;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_modulateinvcolor_addalpha;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_PREMODULATE) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_premodulate;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SELECTARG1) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_selectarg1;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SELECTARG2) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_selectarg2;
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SUBTRACT) TempTextureOpCaps_ = TempTextureOpCaps_ << d3dtexopcaps_subtract;
return TempTextureOpCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetTextureOpCaps_( TD3DDeviceDesc_TextureOpCaps_Set pTextureOpCaps_ )
{
fD3DDEVICEDESC7.dwTextureOpCaps = 0;
if (pTextureOpCaps_.Contains(d3dtexopcaps_add)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_ADD;
if (pTextureOpCaps_.Contains(d3dtexopcaps_addsigned)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_ADDSIGNED;
if (pTextureOpCaps_.Contains(d3dtexopcaps_addsigned2x)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_ADDSIGNED2X;
if (pTextureOpCaps_.Contains(d3dtexopcaps_addsmooth)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_ADDSMOOTH;
if (pTextureOpCaps_.Contains(d3dtexopcaps_blendcurrentalpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BLENDCURRENTALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_blenddiffusealpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BLENDDIFFUSEALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_blendfactoralpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BLENDFACTORALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_blendtexturealpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BLENDTEXTUREALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_blendtexturealphapm)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BLENDTEXTUREALPHAPM;
if (pTextureOpCaps_.Contains(d3dtexopcaps_bumpenvmap)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BUMPENVMAP;
if (pTextureOpCaps_.Contains(d3dtexopcaps_bumpenvmapluminance)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_BUMPENVMAPLUMINANCE;
if (pTextureOpCaps_.Contains(d3dtexopcaps_disable)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_DISABLE;
if (pTextureOpCaps_.Contains(d3dtexopcaps_dotproduct3)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_DOTPRODUCT3;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulate)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATE;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulate2x)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATE2X;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulate4x)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATE4X;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulatealpha_addcolor)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulatecolor_addalpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulateinvalpha_addcolor)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR;
if (pTextureOpCaps_.Contains(d3dtexopcaps_modulateinvcolor_addalpha)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA;
if (pTextureOpCaps_.Contains(d3dtexopcaps_premodulate)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_PREMODULATE;
if (pTextureOpCaps_.Contains(d3dtexopcaps_selectarg1)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_SELECTARG1;
if (pTextureOpCaps_.Contains(d3dtexopcaps_selectarg2)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_SELECTARG2;
if (pTextureOpCaps_.Contains(d3dtexopcaps_subtract)) fD3DDEVICEDESC7.dwTextureOpCaps |= D3DTEXOPCAPS_SUBTRACT;
}
// --------------------------------------------------------------------------
// Method:      FGetTextureOpCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'TextureOpCaps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DDeviceDesc::FGetTextureOpCaps_Strings()
{
// if the strings have not been allocated
if (fTextureOpCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fTextureOpCaps_Strings = new TStringList();
    // if the allocation failed
    if (fTextureOpCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDeviceDesc::FGetTextureOpCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various TextureOpCaps_Strings" );
        return NULL;
        }
    }
fTextureOpCaps_Strings->Clear();
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADD) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_ADD");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSIGNED) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_ADDSIGNED");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSIGNED2X) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_ADDSIGNED2X");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_ADDSMOOTH) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_ADDSMOOTH");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDCURRENTALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BLENDCURRENTALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDDIFFUSEALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BLENDDIFFUSEALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDFACTORALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BLENDFACTORALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BLENDTEXTUREALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHAPM) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BLENDTEXTUREALPHAPM");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BUMPENVMAP) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BUMPENVMAP");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_BUMPENVMAPLUMINANCE) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_BUMPENVMAPLUMINANCE");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_DISABLE) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_DISABLE");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_DOTPRODUCT3) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_DOTPRODUCT3");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATE");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE2X) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATE2X");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATE4X) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATE4X");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_PREMODULATE) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_PREMODULATE");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SELECTARG1) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_SELECTARG1");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SELECTARG2) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_SELECTARG2");
if (fD3DDEVICEDESC7.dwTextureOpCaps & D3DTEXOPCAPS_SUBTRACT) fTextureOpCaps_Strings->Add("D3DTEXOPCAPS_SUBTRACT");
return fTextureOpCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetVertexProcessingCaps_
// Description: This method returns a 
//              TD3DDeviceDesc_VertexProcessingCaps_Set<> of the flags in the 
//              current fD3DDEVICEDESC7.dwReserved4. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DDeviceDesc_VertexProcessingCaps_Set __fastcall TD3DDeviceDesc::FGetVertexProcessingCaps_()
{
TD3DDeviceDesc_VertexProcessingCaps_Set TempVertexProcessingCaps_;
TempVertexProcessingCaps_.Clear();
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_DIRECTIONALLIGHTS) TempVertexProcessingCaps_ = TempVertexProcessingCaps_ << d3dvtxpcaps_directionallights;
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_MATERIALSOURCE7) TempVertexProcessingCaps_ = TempVertexProcessingCaps_ << d3dvtxpcaps_materialsource7;
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_POSITIONALLIGHTS) TempVertexProcessingCaps_ = TempVertexProcessingCaps_ << d3dvtxpcaps_positionallights;
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_TEXGEN) TempVertexProcessingCaps_ = TempVertexProcessingCaps_ << d3dvtxpcaps_texgen;
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_VERTEXFOG) TempVertexProcessingCaps_ = TempVertexProcessingCaps_ << d3dvtxpcaps_vertexfog;
return TempVertexProcessingCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DDeviceDesc::FSetVertexProcessingCaps_( TD3DDeviceDesc_VertexProcessingCaps_Set pVertexProcessingCaps_ )
{
fD3DDEVICEDESC7.dwReserved4 = 0;
if (pVertexProcessingCaps_.Contains(d3dvtxpcaps_directionallights)) fD3DDEVICEDESC7.dwReserved4 |= D3DVTXPCAPS_DIRECTIONALLIGHTS;
if (pVertexProcessingCaps_.Contains(d3dvtxpcaps_materialsource7)) fD3DDEVICEDESC7.dwReserved4 |= D3DVTXPCAPS_MATERIALSOURCE7;
if (pVertexProcessingCaps_.Contains(d3dvtxpcaps_positionallights)) fD3DDEVICEDESC7.dwReserved4 |= D3DVTXPCAPS_POSITIONALLIGHTS;
if (pVertexProcessingCaps_.Contains(d3dvtxpcaps_texgen)) fD3DDEVICEDESC7.dwReserved4 |= D3DVTXPCAPS_TEXGEN;
if (pVertexProcessingCaps_.Contains(d3dvtxpcaps_vertexfog)) fD3DDEVICEDESC7.dwReserved4 |= D3DVTXPCAPS_VERTEXFOG;
}
// --------------------------------------------------------------------------
// Method:      FGetVertexProcessingCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'VertexProcessingCaps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DDeviceDesc::FGetVertexProcessingCaps_Strings()
{
// if the strings have not been allocated
if (fVertexProcessingCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fVertexProcessingCaps_Strings = new TStringList();
    // if the allocation failed
    if (fVertexProcessingCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DDeviceDesc::FGetVertexProcessingCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various VertexProcessingCaps_Strings" );
        return NULL;
        }
    }
fVertexProcessingCaps_Strings->Clear();
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_DIRECTIONALLIGHTS) fVertexProcessingCaps_Strings->Add("D3DVTXPCAPS_DIRECTIONALLIGHTS");
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_MATERIALSOURCE7) fVertexProcessingCaps_Strings->Add("D3DVTXPCAPS_MATERIALSOURCE7");
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_POSITIONALLIGHTS) fVertexProcessingCaps_Strings->Add("D3DVTXPCAPS_POSITIONALLIGHTS");
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_TEXGEN) fVertexProcessingCaps_Strings->Add("D3DVTXPCAPS_TEXGEN");
if (fD3DDEVICEDESC7.dwReserved4 & D3DVTXPCAPS_VERTEXFOG) fVertexProcessingCaps_Strings->Add("D3DVTXPCAPS_VERTEXFOG");
return fVertexProcessingCaps_Strings;
}
// --------------------------------------------------------------------------
