// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DLightingCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DLightingCaps 
//               Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DLightingCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DLightingCaps*)
{
    new TD3DLightingCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dlightingcaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DLightingCaps)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DLightingCaps::TD3DLightingCaps()
// Description: The default constructor for the TD3DLightingCaps object.
// --------------------------------------------------------------------------
__fastcall TD3DLightingCaps::TD3DLightingCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fCaps_Strings=NULL;
fLightingModel_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TD3DLightingCaps::~TD3DLightingCaps()
// Description: The destructor for the TD3DLightingCaps object.
// --------------------------------------------------------------------------
__fastcall TD3DLightingCaps::~TD3DLightingCaps()
{
if (fCaps_Strings!=NULL) delete fCaps_Strings;
if (fLightingModel_Strings!=NULL) delete fLightingModel_Strings;
}
// --------------------------------------------------------------------------
// Property:    Caps
// Description: The Caps property defines the types of light source supported 
//              by the lighting module. 
//              The described effect applies when the flag is set. 
// Flags:       D3DLIGHTCAPS_DIRECTIONAL -
//                Support for directional lights is available. 
//              D3DLIGHTCAPS_POINT -
//                Support for point lights is available. 
//              D3DLIGHTCAPS_SPOT -
//                Support for spotlights is available. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLightingCaps::FGetCaps()
{
return fD3DLIGHTINGCAPS.dwCaps;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetCaps( dword pCaps )
{
fD3DLIGHTINGCAPS.dwCaps = pCaps;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DLightingCaps method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DLightingCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    LightingModel
// Description: The LightingModel property defines the lighting model being 
//              used. 
//              The described effect applies when the flag is set. 
// Flags:       D3DLIGHTINGMODEL_MONO -
//                The lighting model being utilised is the monochromatic or 
//                ramp lighting model. 
//                
//                The blue color component is converted into grey scale and 
//                the other values are ignored in the monochrome model. 
//              D3DLIGHTINGMODEL_RGB -
//                The lighting model being utilised is the RGB or color 
//                lighting model. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLightingCaps::FGetLightingModel()
{
return fD3DLIGHTINGCAPS.dwLightingModel;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetLightingModel( dword pLightingModel )
{
fD3DLIGHTINGCAPS.dwLightingModel = pLightingModel;
}
// --------------------------------------------------------------------------
// Property:    NumLights
// Description: The NumLights property defines how many lights can be 
//              supported. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLightingCaps::FGetNumLights()
{
return fD3DLIGHTINGCAPS.dwNumLights;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetNumLights( dword pNumLights )
{
fD3DLIGHTINGCAPS.dwNumLights = pNumLights;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DLIGHTINGCAPS structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLightingCaps::FGetSize()
{
return fD3DLIGHTINGCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetSize( dword pSize )
{
fD3DLIGHTINGCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DLightingCaps's internal D3DLIGHTINGCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::Clear()
{
fD3DLIGHTINGCAPS.dwCaps = 0;
fErrorValue = D3D_OK;
fD3DLIGHTINGCAPS.dwLightingModel = 0;
fD3DLIGHTINGCAPS.dwNumLights = 0;
fD3DLIGHTINGCAPS.dwSize = sizeof(D3DLIGHTINGCAPS);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DLIGHTINGCAPS* __fastcall TD3DLightingCaps::FGetInternal_D3DLIGHTINGCAPS_Ptr()
{
return &fD3DLIGHTINGCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetInternal_D3DLIGHTINGCAPS( D3DLIGHTINGCAPS* pD3DLIGHTINGCAPS )
{
if (pD3DLIGHTINGCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DLightingCaps::FSetInternal_D3DLIGHTINGCAPS()", "TDX_ERROR", "The supplied D3DLIGHTINGCAPS* was NULL" );
    return;
    }

CopyMemory( &fD3DLIGHTINGCAPS, pD3DLIGHTINGCAPS, sizeof(D3DLIGHTINGCAPS) );
Internal_D3DLIGHTINGCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::Internal_D3DLIGHTINGCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetCaps_
// Description: This method returns a TD3DLightingCaps_Caps_Set<> of the 
//              flags in the current fD3DLIGHTINGCAPS.dwCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DLightingCaps_Caps_Set __fastcall TD3DLightingCaps::FGetCaps_()
{
TD3DLightingCaps_Caps_Set TempCaps_;
TempCaps_.Clear();
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_DIRECTIONAL) TempCaps_ = TempCaps_ << d3dlightcaps_directional;
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_POINT) TempCaps_ = TempCaps_ << d3dlightcaps_point;
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_SPOT) TempCaps_ = TempCaps_ << d3dlightcaps_spot;
return TempCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetCaps_( TD3DLightingCaps_Caps_Set pCaps_ )
{
fD3DLIGHTINGCAPS.dwCaps = 0;
if (pCaps_.Contains(d3dlightcaps_directional)) fD3DLIGHTINGCAPS.dwCaps |= D3DLIGHTCAPS_DIRECTIONAL;
if (pCaps_.Contains(d3dlightcaps_point)) fD3DLIGHTINGCAPS.dwCaps |= D3DLIGHTCAPS_POINT;
if (pCaps_.Contains(d3dlightcaps_spot)) fD3DLIGHTINGCAPS.dwCaps |= D3DLIGHTCAPS_SPOT;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DLightingCaps::FGetCaps_Strings()
{
// if the strings have not been allocated
if (fCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps_Strings = new TStringList();
    // if the allocation failed
    if (fCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DLightingCaps::FGetCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps_Strings" );
        return NULL;
        }
    }
fCaps_Strings->Clear();
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_DIRECTIONAL) fCaps_Strings->Add("D3DLIGHTCAPS_DIRECTIONAL");
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_POINT) fCaps_Strings->Add("D3DLIGHTCAPS_POINT");
if (fD3DLIGHTINGCAPS.dwCaps & D3DLIGHTCAPS_SPOT) fCaps_Strings->Add("D3DLIGHTCAPS_SPOT");
return fCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetLightingModel_
// Description: This method returns a TD3DLightingCaps_LightingModel_Set<> of 
//              the flags in the current fD3DLIGHTINGCAPS.dwLightingModel. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TD3DLightingCaps_LightingModel_Set __fastcall TD3DLightingCaps::FGetLightingModel_()
{
TD3DLightingCaps_LightingModel_Set TempLightingModel_;
TempLightingModel_.Clear();
if (fD3DLIGHTINGCAPS.dwLightingModel & D3DLIGHTINGMODEL_MONO) TempLightingModel_ = TempLightingModel_ << d3dlightingmodel_mono;
if (fD3DLIGHTINGCAPS.dwLightingModel & D3DLIGHTINGMODEL_RGB) TempLightingModel_ = TempLightingModel_ << d3dlightingmodel_rgb;
return TempLightingModel_;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLightingCaps::FSetLightingModel_( TD3DLightingCaps_LightingModel_Set pLightingModel_ )
{
fD3DLIGHTINGCAPS.dwLightingModel = 0;
if (pLightingModel_.Contains(d3dlightingmodel_mono)) fD3DLIGHTINGCAPS.dwLightingModel |= D3DLIGHTINGMODEL_MONO;
if (pLightingModel_.Contains(d3dlightingmodel_rgb)) fD3DLIGHTINGCAPS.dwLightingModel |= D3DLIGHTINGMODEL_RGB;
}
// --------------------------------------------------------------------------
// Method:      FGetLightingModel_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'LightingModel' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TD3DLightingCaps::FGetLightingModel_Strings()
{
// if the strings have not been allocated
if (fLightingModel_Strings==NULL)
    {
    // attempt to allocate the strings
    fLightingModel_Strings = new TStringList();
    // if the allocation failed
    if (fLightingModel_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DLightingCaps::FGetLightingModel_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various LightingModel_Strings" );
        return NULL;
        }
    }
fLightingModel_Strings->Clear();
if (fD3DLIGHTINGCAPS.dwLightingModel & D3DLIGHTINGMODEL_MONO) fLightingModel_Strings->Add("D3DLIGHTINGMODEL_MONO");
if (fD3DLIGHTINGCAPS.dwLightingModel & D3DLIGHTINGMODEL_RGB) fLightingModel_Strings->Add("D3DLIGHTINGMODEL_RGB");
return fLightingModel_Strings;
}
// --------------------------------------------------------------------------
