// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DTLVertex.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DTLVertex Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DTLVertex.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DTLVertex*)
{
    new TD3DTLVertex(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dtlvertex
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DTLVertex)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DTLVertex::TD3DTLVertex()
// Description: The default constructor for the TD3DTLVertex object.
// --------------------------------------------------------------------------
__fastcall TD3DTLVertex::TD3DTLVertex(TComponent* Owner)
    : TComponent(Owner)
{
fD3DTLVERTEX=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DTLVertex::~TD3DTLVertex()
// Description: The destructor for the TD3DTLVertex object.
// --------------------------------------------------------------------------
__fastcall TD3DTLVertex::~TD3DTLVertex()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DTLVERTEX structures wrapped inside the TD3DTLVertex 
//              component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DTLVertex component wraps a single D3DTLVERTEX 
//              structure. To wrap multiple structures, set the 
//              TD3DTLVertex::ArraySize to the total number of internal 
//              structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DTLVertex::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DTLVERTEX;
    fD3DTLVERTEX = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DTLVERTEX = new D3DTLVERTEX[pArraySize];
    if (fD3DTLVERTEX==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DTLVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DTLVERTEX structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DTLVERTEX* temp_D3DTLVERTEX = new D3DTLVERTEX[pArraySize];
        if (temp_D3DTLVERTEX==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DTLVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DTLVERTEX structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DTLVERTEX[fArraySize], sizeof(D3DTLVERTEX)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DTLVERTEX[0], &fD3DTLVERTEX[0], sizeof(D3DTLVERTEX)*fArraySize);
        // de-allocate old memory
        delete[] fD3DTLVERTEX;
        // re-assign the new memory
        fD3DTLVERTEX = temp_D3DTLVERTEX;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DTLVERTEX* temp_D3DTLVERTEX = new D3DTLVERTEX[pArraySize];
            if (temp_D3DTLVERTEX==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DTLVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DTLVERTEX structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DTLVERTEX[0], &fD3DTLVERTEX[0], sizeof(D3DTLVERTEX)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DTLVERTEX;
            // re-assign the new memory
            fD3DTLVERTEX = temp_D3DTLVERTEX;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Color
// Description: The Color property contains a D3DCOLOR defining the color 
//              component of the vertex. 
//              
//              This property is unioned with the color property of this 
//              component. 
// --------------------------------------------------------------------------
D3DCOLOR __fastcall TD3DTLVertex::FGetColor( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetColor()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DCOLOR) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetColor()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DCOLOR) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dcColor;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetColor( dword pArrayIndex, D3DCOLOR pColor )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetColor()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetColor()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dcColor = pColor;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DTLVertex method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DTLVertex::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    RHW
// Description: The RHW property contains a D3DVALUE defining the reciprocal 
//              of homogenous w from the homogenous coordinates (x,y,z,w). 
//              
//              Usually this is 1 divided by the objects z-distance from the 
//              origin. 
//              This property is unioned with the rhw property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetRHW( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetRHW()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetRHW()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvRHW;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetRHW( dword pArrayIndex, D3DVALUE pRHW )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetRHW()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetRHW()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvRHW = pRHW;
}
// --------------------------------------------------------------------------
// Property:    SX
// Description: The SX property contains a D3DVALUE defining the X axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the sx property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetSX( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSX()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvSX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetSX( dword pArrayIndex, D3DVALUE pSX )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSX()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvSX = pSX;
}
// --------------------------------------------------------------------------
// Property:    SY
// Description: The SY property contains a D3DVALUE defining the Y axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the sy property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetSY( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSY()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvSY;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetSY( dword pArrayIndex, D3DVALUE pSY )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSY()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvSY = pSY;
}
// --------------------------------------------------------------------------
// Property:    SZ
// Description: The SZ property contains a D3DVALUE defining the Z axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the sz property of this 
//              component and cannot exceed 0.99999 and not be clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetSZ( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSZ()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvSZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetSZ( dword pArrayIndex, D3DVALUE pSZ )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSZ()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvSZ = pSZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DTLVERTEX structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DTLVertex::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DTLVERTEX structures. This result is the same as 
//              multiplying TD3DTLVertex::ArraySize and TD3DTLVertex::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DTLVertex::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    Specular
// Description: The Specular property contains a D3DCOLOR defining the 
//              specular color component of the vertex. 
//              
//              This property is unioned with the specular property of this 
//              component. 
// --------------------------------------------------------------------------
D3DCOLOR __fastcall TD3DTLVertex::FGetSpecular( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSpecular()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DCOLOR) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetSpecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DCOLOR) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dcSpecular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetSpecular( dword pArrayIndex, D3DCOLOR pSpecular )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSpecular()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetSpecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dcSpecular = pSpecular;
}
// --------------------------------------------------------------------------
// Property:    TU
// Description: The TU property contains a D3DVALUE specifying the U texture 
//              coordinate of the vertex. 
//              
//              This property is unioned with the tu property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetTU( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetTU()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetTU()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvTU;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetTU( dword pArrayIndex, D3DVALUE pTU )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetTU()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetTU()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvTU = pTU;
}
// --------------------------------------------------------------------------
// Property:    TV
// Description: The TV property contains a D3DVALUE specifying the U texture 
//              coordinate of the vertex. 
//              
//              This property is unioned with the tv property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetTV( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetTV()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetTV()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].dvTV;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetTV( dword pArrayIndex, D3DVALUE pTV )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetTV()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetTV()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].dvTV = pTV;
}
// --------------------------------------------------------------------------
// Property:    color
// Description: The color property contains a D3DCOLOR defining the color 
//              component of the vertex. 
//              
//              This property is unioned with the Color property of this 
//              component. 
// --------------------------------------------------------------------------
D3DCOLOR __fastcall TD3DTLVertex::FGetcolor( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetcolor()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DCOLOR) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetcolor()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DCOLOR) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].color;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetcolor( dword pArrayIndex, D3DCOLOR pcolor )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetcolor()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetcolor()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].color = pcolor;
}
// --------------------------------------------------------------------------
// Property:    rhw
// Description: The rhw property contains a D3DVALUE defining the reciprocal 
//              of homogenous w from the homogenous coordinates (x,y,z,w). 
//              
//              Usually this is 1 divided by the objects z-distance from the 
//              origin. 
//              This property is unioned with the RHW property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetrhw( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetrhw()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetrhw()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].rhw;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetrhw( dword pArrayIndex, D3DVALUE prhw )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetrhw()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetrhw()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].rhw = prhw;
}
// --------------------------------------------------------------------------
// Property:    specular
// Description: The specular property contains a D3DCOLOR defining the 
//              specular color component of the vertex. 
//              
//              This property is unioned with the Specular property of this 
//              component. 
// --------------------------------------------------------------------------
D3DCOLOR __fastcall TD3DTLVertex::FGetspecular( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetspecular()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DCOLOR) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetspecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DCOLOR) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].specular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetspecular( dword pArrayIndex, D3DCOLOR pspecular )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetspecular()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetspecular()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].specular = pspecular;
}
// --------------------------------------------------------------------------
// Property:    sx
// Description: The sx property contains a D3DVALUE defining the X axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the SX property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetsx( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsx()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].sx;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetsx( dword pArrayIndex, D3DVALUE psx )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsx()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].sx = psx;
}
// --------------------------------------------------------------------------
// Property:    sy
// Description: The sy property contains a D3DVALUE defining the Y axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the SY property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetsy( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsy()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsy()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].sy;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetsy( dword pArrayIndex, D3DVALUE psy )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsy()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsy()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].sy = psy;
}
// --------------------------------------------------------------------------
// Property:    sz
// Description: The sz property contains a D3DVALUE defining the Z axis 
//              screen coordinate of the vertex. 
//              
//              This property is unioned with the SZ property of this 
//              component and cannot exceed 0.99999 and not be clipped. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGetsz( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsz()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGetsz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].sz;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetsz( dword pArrayIndex, D3DVALUE psz )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsz()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSetsz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].sz = psz;
}
// --------------------------------------------------------------------------
// Property:    tu
// Description: The tu property contains a D3DVALUE specifying the U texture 
//              coordinate of the vertex. 
//              
//              This property is unioned with the TU property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGettu( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGettu()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGettu()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].tu;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSettu( dword pArrayIndex, D3DVALUE ptu )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSettu()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSettu()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].tu = ptu;
}
// --------------------------------------------------------------------------
// Property:    tv
// Description: The tv property contains a D3DVALUE specifying the U texture 
//              coordinate of the vertex. 
//              
//              This property is unioned with the TV property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DTLVertex::FGettv( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGettv()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FGettv()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DTLVERTEX[pArrayIndex].tv;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSettv( dword pArrayIndex, D3DVALUE ptv )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSettv()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::FSettv()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DTLVERTEX[pArrayIndex].tv = ptv;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DTLVertex's internal D3DTLVERTEX structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DTLVertex::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DTLVERTEX[pArrayIndex], sizeof(D3DTLVERTEX) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DTLVERTEX structures of the TD3DTLVertex 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DTLVertex::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DTLVERTEX[0], sizeof(D3DTLVERTEX)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DTLVERTEX* __fastcall TD3DTLVertex::FGetInternal_D3DTLVERTEX_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DTLVertex::FGetInternal_D3DTLVERTEX_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fD3DTLVERTEX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::FSetInternal_D3DTLVERTEX( dword pArrayIndex, D3DTLVERTEX* pD3DTLVERTEX )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DTLVertex::FSetInternal_D3DTLVERTEX()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DTLVERTEX==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DTLVertex::FSetInternal_D3DTLVERTEX()", "TDX_ERROR", "The supplied D3DTLVERTEX* was NULL" );
    return;
    }
CopyMemory( &fD3DTLVERTEX[pArrayIndex], pD3DTLVERTEX, sizeof(D3DTLVERTEX) );
Internal_D3DTLVERTEX_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DTLVertex::Internal_D3DTLVERTEX_Update()
{
}

// --------------------------------------------------------------------------
