// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DVector.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DVector Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DVector.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DVector*)
{
    new TD3DVector(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dvector
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DVector)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DVector::TD3DVector()
// Description: The default constructor for the TD3DVector object.
// --------------------------------------------------------------------------
__fastcall TD3DVector::TD3DVector(TComponent* Owner)
    : TComponent(Owner)
{
fD3DVECTOR=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DVector::~TD3DVector()
// Description: The destructor for the TD3DVector object.
// --------------------------------------------------------------------------
__fastcall TD3DVector::~TD3DVector()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DVECTOR structures wrapped inside the TD3DVector component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DVector component wraps a single D3DVECTOR structure. 
//              To wrap multiple structures, set the TD3DVector::ArraySize to 
//              the total number of internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVector::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DVECTOR;
    fD3DVECTOR = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DVECTOR = new D3DVECTOR[pArraySize];
    if (fD3DVECTOR==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DVECTOR::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DVECTOR structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DVECTOR* temp_D3DVECTOR = new D3DVECTOR[pArraySize];
        if (temp_D3DVECTOR==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DVECTOR::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DVECTOR structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DVECTOR[fArraySize], sizeof(D3DVECTOR)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DVECTOR[0], &fD3DVECTOR[0], sizeof(D3DVECTOR)*fArraySize);
        // de-allocate old memory
        delete[] fD3DVECTOR;
        // re-assign the new memory
        fD3DVECTOR = temp_D3DVECTOR;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DVECTOR* temp_D3DVECTOR = new D3DVECTOR[pArraySize];
            if (temp_D3DVECTOR==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DVECTOR::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DVECTOR structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DVECTOR[0], &fD3DVECTOR[0], sizeof(D3DVECTOR)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DVECTOR;
            // re-assign the new memory
            fD3DVECTOR = temp_D3DVECTOR;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DVector method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DVector::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DVECTOR structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVector::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DVECTOR structures. This result is the same as 
//              multiplying TD3DVector::ArraySize and TD3DVector::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVector::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property defines the X axis value of the vector. 
//              
//              This property is unioned with the x property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGetX( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetX()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].dvX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetX( dword pArrayIndex, D3DVALUE pX )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetX()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].dvX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property defines the Y axis value of the vector. 
//              
//              This property is unioned with the y property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGetY( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetY()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].dvY;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetY( dword pArrayIndex, D3DVALUE pY )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetY()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].dvY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property defines the Z axis value of the vector. 
//              
//              This property is unioned with the z property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGetZ( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetZ()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].dvZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetZ( dword pArrayIndex, D3DVALUE pZ )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetZ()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].dvZ = pZ;
}
// --------------------------------------------------------------------------
// Property:    x
// Description: The x property defines the X axis value of the vector. 
//              
//              This property is unioned with the X property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGetx( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetx()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].x;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetx( dword pArrayIndex, D3DVALUE px )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetx()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].x = px;
}
// --------------------------------------------------------------------------
// Property:    y
// Description: The y property defines the Y axis value of the vector. 
//              
//              This property is unioned with the Y property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGety( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGety()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGety()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].y;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSety( dword pArrayIndex, D3DVALUE py )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSety()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSety()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].y = py;
}
// --------------------------------------------------------------------------
// Property:    z
// Description: The z property defines the Z axis value of the vector. 
//              
//              This property is unioned with the Z property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVector::FGetz( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetz()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FGetz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVECTOR[pArrayIndex].z;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetz( dword pArrayIndex, D3DVALUE pz )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetz()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::FSetz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVECTOR[pArrayIndex].z = pz;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DVector's internal D3DVECTOR structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DVector::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DVector::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DVECTOR[pArrayIndex], sizeof(D3DVECTOR) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DVECTOR structures of the TD3DVector 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DVector::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVector::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DVECTOR[0], sizeof(D3DVECTOR)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DVECTOR* __fastcall TD3DVector::FGetInternal_D3DVECTOR_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVector::FGetInternal_D3DVECTOR_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fD3DVECTOR;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::FSetInternal_D3DVECTOR( dword pArrayIndex, D3DVECTOR* pD3DVECTOR )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVector::FSetInternal_D3DVECTOR()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DVECTOR==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVector::FSetInternal_D3DVECTOR()", "TDX_ERROR", "The supplied D3DVECTOR* was NULL" );
    return;
    }
CopyMemory( &fD3DVECTOR[pArrayIndex], pD3DVECTOR, sizeof(D3DVECTOR) );
Internal_D3DVECTOR_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DVector::Internal_D3DVECTOR_Update()
{
}

// --------------------------------------------------------------------------
