// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DVertex.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DVertex Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DVertex.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DVertex*)
{
    new TD3DVertex(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dvertex
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DVertex)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DVertex::TD3DVertex()
// Description: The default constructor for the TD3DVertex object.
// --------------------------------------------------------------------------
__fastcall TD3DVertex::TD3DVertex(TComponent* Owner)
    : TComponent(Owner)
{
fD3DVERTEX=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DVertex::~TD3DVertex()
// Description: The destructor for the TD3DVertex object.
// --------------------------------------------------------------------------
__fastcall TD3DVertex::~TD3DVertex()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DVERTEX structures wrapped inside the TD3DVertex component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DVertex component wraps a single D3DVERTEX structure. 
//              To wrap multiple structures, set the TD3DVertex::ArraySize to 
//              the total number of internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertex::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DVERTEX;
    fD3DVERTEX = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DVERTEX = new D3DVERTEX[pArraySize];
    if (fD3DVERTEX==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DVERTEX structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DVERTEX* temp_D3DVERTEX = new D3DVERTEX[pArraySize];
        if (temp_D3DVERTEX==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DVERTEX structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DVERTEX[fArraySize], sizeof(D3DVERTEX)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DVERTEX[0], &fD3DVERTEX[0], sizeof(D3DVERTEX)*fArraySize);
        // de-allocate old memory
        delete[] fD3DVERTEX;
        // re-assign the new memory
        fD3DVERTEX = temp_D3DVERTEX;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DVERTEX* temp_D3DVERTEX = new D3DVERTEX[pArraySize];
            if (temp_D3DVERTEX==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DVERTEX::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DVERTEX structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DVERTEX[0], &fD3DVERTEX[0], sizeof(D3DVERTEX)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DVERTEX;
            // re-assign the new memory
            fD3DVERTEX = temp_D3DVERTEX;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DVertex method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DVertex::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    NX
// Description: The NX property contains a D3DVALUE defining the X axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the nx property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetNX( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNX()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvNX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetNX( dword pArrayIndex, D3DVALUE pNX )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNX()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvNX = pNX;
}
// --------------------------------------------------------------------------
// Property:    NY
// Description: The NY property contains a D3DVALUE defining the Y axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the ny property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetNY( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNY()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvNY;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetNY( dword pArrayIndex, D3DVALUE pNY )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNY()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvNY = pNY;
}
// --------------------------------------------------------------------------
// Property:    NZ
// Description: The NZ property contains a D3DVALUE defining the Z axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the nz property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetNZ( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNZ()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetNZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvNZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetNZ( dword pArrayIndex, D3DVALUE pNZ )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNZ()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetNZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvNZ = pNZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DVERTEX structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertex::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DVERTEX structures. This result is the same as 
//              multiplying TD3DVertex::ArraySize and TD3DVertex::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DVertex::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    TU
// Description: The TU property contains a D3DVALUE defining the U texture 
//              coordinate of this vertex. 
//              
//              This property is unioned with the tu property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetTU( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetTU()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetTU()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvTU;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetTU( dword pArrayIndex, D3DVALUE pTU )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetTU()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetTU()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvTU = pTU;
}
// --------------------------------------------------------------------------
// Property:    TV
// Description: The TV property contains a D3DVALUE defining the V texture 
//              coordinate of this vertex. 
//              
//              This property is unioned with the tv property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetTV( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetTV()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetTV()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvTV;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetTV( dword pArrayIndex, D3DVALUE pTV )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetTV()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetTV()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvTV = pTV;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property contains a D3DVALUE defining the homogenous X 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the x property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetX( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetX()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetX( dword pArrayIndex, D3DVALUE pX )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetX()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetX()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property contains a D3DVALUE defining the homogenous Y 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the y property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetY( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetY()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvY;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetY( dword pArrayIndex, D3DVALUE pY )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetY()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetY()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property contains a D3DVALUE defining the homogenous Z 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the z property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetZ( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetZ()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].dvZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetZ( dword pArrayIndex, D3DVALUE pZ )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetZ()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetZ()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].dvZ = pZ;
}
// --------------------------------------------------------------------------
// Property:    nx
// Description: The nx property contains a D3DVALUE defining the X axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the NX property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetnx( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetnx()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetnx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].nx;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetnx( dword pArrayIndex, D3DVALUE pnx )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetnx()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetnx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].nx = pnx;
}
// --------------------------------------------------------------------------
// Property:    ny
// Description: The ny property contains a D3DVALUE defining the Y axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the NY property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetny( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetny()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetny()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].ny;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetny( dword pArrayIndex, D3DVALUE pny )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetny()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetny()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].ny = pny;
}
// --------------------------------------------------------------------------
// Property:    nz
// Description: The nz property contains a D3DVALUE defining the Z axis 
//              coordinate of the normal vector of this vertex. 
//              
//              This property is unioned with the NZ property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetnz( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetnz()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetnz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].nz;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetnz( dword pArrayIndex, D3DVALUE pnz )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetnz()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetnz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].nz = pnz;
}
// --------------------------------------------------------------------------
// Property:    tu
// Description: The tu property contains a D3DVALUE defining the U texture 
//              coordinate of this vertex. 
//              
//              This property is unioned with the TU property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGettu( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGettu()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGettu()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].tu;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSettu( dword pArrayIndex, D3DVALUE ptu )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSettu()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSettu()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].tu = ptu;
}
// --------------------------------------------------------------------------
// Property:    tv
// Description: The tv property contains a D3DVALUE defining the V texture 
//              coordinate of this vertex. 
//              
//              This property is unioned with the TV property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGettv( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGettv()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGettv()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].tv;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSettv( dword pArrayIndex, D3DVALUE ptv )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSettv()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSettv()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].tv = ptv;
}
// --------------------------------------------------------------------------
// Property:    x
// Description: The x property contains a D3DVALUE defining the homogenous X 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the X property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetx( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetx()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].x;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetx( dword pArrayIndex, D3DVALUE px )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetx()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetx()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].x = px;
}
// --------------------------------------------------------------------------
// Property:    y
// Description: The y property contains a D3DVALUE defining the homogenous Y 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the Y property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGety( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGety()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGety()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].y;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSety( dword pArrayIndex, D3DVALUE py )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSety()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSety()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].y = py;
}
// --------------------------------------------------------------------------
// Property:    z
// Description: The z property contains a D3DVALUE defining the homogenous Z 
//              axis coordinate. 
//              
//              This value is relative to the origin specified for the 
//              objects model space. 
//              This property is unioned with the Z property of this 
//              component. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DVertex::FGetz( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetz()", "TDX_ERROR", "Internal Array size is 0.");
    return (D3DVALUE) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FGetz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return (D3DVALUE) NULL;
    }

return fD3DVERTEX[pArrayIndex].z;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetz( dword pArrayIndex, D3DVALUE pz )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetz()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::FSetz()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DVERTEX[pArrayIndex].z = pz;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DVertex's internal D3DVERTEX structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DVertex::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DVERTEX[pArrayIndex], sizeof(D3DVERTEX) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DVERTEX structures of the TD3DVertex 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DVertex::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DVERTEX[0], sizeof(D3DVERTEX)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DVERTEX* __fastcall TD3DVertex::FGetInternal_D3DVERTEX_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVertex::FGetInternal_D3DVERTEX_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fD3DVERTEX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::FSetInternal_D3DVERTEX( dword pArrayIndex, D3DVERTEX* pD3DVERTEX )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVertex::FSetInternal_D3DVERTEX()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DVERTEX==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DVertex::FSetInternal_D3DVERTEX()", "TDX_ERROR", "The supplied D3DVERTEX* was NULL" );
    return;
    }
CopyMemory( &fD3DVERTEX[pArrayIndex], pD3DVERTEX, sizeof(D3DVERTEX) );
Internal_D3DVERTEX_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DVertex::Internal_D3DVERTEX_Update()
{
}

// --------------------------------------------------------------------------
