// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DViewPort.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (documentation)
// Description:  This file contains the code for the TD3DViewPort Component 
//
// "TDx_3DI_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DViewPort.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_3DI_Library_Defns"
#pragma link "TDx_3DI_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DViewPort*)
{
    new TD3DViewPort(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dviewport
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DViewPort)};
        RegisterComponents("TDx_3DI", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DViewPort::TD3DViewPort()
// Description: The default constructor for the TD3DViewPort object.
// --------------------------------------------------------------------------
__fastcall TD3DViewPort::TD3DViewPort(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DViewPort::~TD3DViewPort()
// Description: The destructor for the TD3DViewPort object.
// --------------------------------------------------------------------------
__fastcall TD3DViewPort::~TD3DViewPort()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DViewPort method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DViewPort::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Height
// Description: The Height property defines the height of the viewport, in 
//              pixels. 
// --------------------------------------------------------------------------
dword __fastcall TD3DViewPort::FGetHeight()
{
return fD3DVIEWPORT7.dwHeight;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetHeight( dword pHeight )
{
fD3DVIEWPORT7.dwHeight = pHeight;
}
// --------------------------------------------------------------------------
// Property:    MaxZ
// Description: The MaxZ property contains a D3DVALUE defining the maximum 
//              nonhomogenous Z coordinate. 
//              
//              Usually this value is 1.0 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DViewPort::FGetMaxZ()
{
return fD3DVIEWPORT7.dvMaxZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetMaxZ( D3DVALUE pMaxZ )
{
fD3DVIEWPORT7.dvMaxZ = pMaxZ;
}
// --------------------------------------------------------------------------
// Property:    MinZ
// Description: The MinZ property contains a D3DVALUE defining the minimum 
//              nonhomogenous Z coordinate. 
//              
//              Usually this value is 0.0 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DViewPort::FGetMinZ()
{
return fD3DVIEWPORT7.dvMinZ;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetMinZ( D3DVALUE pMinZ )
{
fD3DVIEWPORT7.dvMinZ = pMinZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DVIEWPORT7 structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DViewPort::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Width
// Description: The Width property defines the width of the viewport, in 
//              pixels. 
// --------------------------------------------------------------------------
dword __fastcall TD3DViewPort::FGetWidth()
{
return fD3DVIEWPORT7.dwWidth;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetWidth( dword pWidth )
{
fD3DVIEWPORT7.dwWidth = pWidth;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property defines the X coordinate of the upper left 
//              corner of the viewport. 
//              
//              Unless rendering to a subarea of the surface, this is usually 
//              0. 
// --------------------------------------------------------------------------
dword __fastcall TD3DViewPort::FGetX()
{
return fD3DVIEWPORT7.dwX;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetX( dword pX )
{
fD3DVIEWPORT7.dwX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property defines the Y coordinate of the upper left 
//              corner of the viewport. 
//              
//              Unless rendering to a subarea of the surface, this is usually 
//              0. 
// --------------------------------------------------------------------------
dword __fastcall TD3DViewPort::FGetY()
{
return fD3DVIEWPORT7.dwY;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetY( dword pY )
{
fD3DVIEWPORT7.dwY = pY;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DViewPort's internal D3DVIEWPORT7 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::Clear()
{
fErrorValue = D3D_OK;
fD3DVIEWPORT7.dwHeight = 0;
fSize = sizeof(D3DVIEWPORT7);
fD3DVIEWPORT7.dwWidth = 0;
fD3DVIEWPORT7.dwX = 0;
fD3DVIEWPORT7.dwY = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DVIEWPORT7* __fastcall TD3DViewPort::FGetInternal_D3DVIEWPORT7_Ptr()
{
return &fD3DVIEWPORT7;
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::FSetInternal_D3DVIEWPORT7( D3DVIEWPORT7* pD3DVIEWPORT7 )
{
if (pD3DVIEWPORT7==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DViewPort::FSetInternal_D3DVIEWPORT7()", "TDX_ERROR", "The supplied D3DVIEWPORT7* was NULL" );
    return;
    }

CopyMemory( &fD3DVIEWPORT7, pD3DVIEWPORT7, sizeof(D3DVIEWPORT7) );
Internal_D3DVIEWPORT7_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DViewPort::Internal_D3DVIEWPORT7_Update()
{
}

// --------------------------------------------------------------------------
